<template>
  <div class="mod-category">
    <el-form :inline="true" :model="dataForm">
      <el-form-item label="店铺名称">
        <el-select v-model="searchForm.shopId" clearable size="small" placeholder="请选择店铺">
          <el-option
            v-for="item in options"
            :key="item.value"
            :label="item.label"
            :value="item.value">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="分类名称">
        <el-input v-model="searchForm.categoryName" size="small" placeholder="请输入分类"></el-input>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          icon="el-icon-search"
          size="small"
          @click="handleSearch"
        >搜索</el-button>
      </el-form-item>
    <el-form-item>
        <el-button
          v-if="isAuth('prod:category:save')"
          type="primary"
          icon="el-icon-plus"
          size="small"
          @click="addOrUpdateHandle()"
        >新增</el-button>
      </el-form-item>
    </el-form>
    <el-table :data="dataList" border row-key="categoryId" style="width: 100%;">
       <el-table-column
        prop="shopName"
        header-align="center"
        treeKey="categoryId"
        label="店铺名称"
      ></el-table-column>
      <el-table-column
        prop="categoryName"
        header-align="center"
        treeKey="categoryId"
        width="150"
        label="分类名称"
      ></el-table-column>
      <el-table-column prop="pic" header-align="center" align="center" label="图片">
        <template slot-scope="scope">
          <img :src="resourcesUrl + scope.row.pic " />
        </template>
      </el-table-column>
      <el-table-column prop="status" header-align="center" align="center" label="状态">
        <template slot-scope="scope">
          <el-tag v-if="scope.row.status === 0" size="small" type="danger">下线</el-tag>
          <el-tag v-else size="small">正常</el-tag>
        </template>
      </el-table-column>
      <el-table-column prop="seq" header-align="center" align="center" label="排序号"></el-table-column>
      <el-table-column fixed="right" header-align="center" align="center" label="操作">
        <template slot-scope="scope">
          <el-button
            v-if="isAuth('prod:category:update')"
            type="primary"
            size="small"
            @click="addOrUpdateHandle(scope.row.categoryId)"
          >修改</el-button>
          <el-button
            v-if="isAuth('prod:category:delete')"
            type="danger"
            size="small"
            @click="deleteHandle(scope.row.categoryId)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      @size-change="handleSizeChange"
      @current-change="handleCurrentChange"
      :current-page="searchForm.current"
      :page-sizes="[10, 20]"
      :page-size="searchForm.size"
      layout="total, sizes, prev, pager, next, jumper"
      :total="total">
    </el-pagination>

    <!-- 弹窗, 新增 / 修改 -->
    <add-or-update v-if="addOrUpdateVisible" ref="addOrUpdate" @refreshDataList="getDataList"></add-or-update>
  </div>
</template>

<script>
import AddOrUpdate from './category-add-or-update'
import { treeDataTranslate } from '@/utils'

export default {
  data () {
    return {
      options: [],
      total:0,
      searchForm:{shopId:undefined,current:1,size:10},
      dataForm: {},
      dataList: [],
      dataListLoading: false,
      addOrUpdateVisible: false,
      resourcesUrl: window.SITE_CONFIG.resourcesUrl
    }
  },
  components: {
    AddOrUpdate
  },
  created () {
    this.getDataList()
    this.getShopByName()
  },
  methods: {
    handleSearch(){
      this.searchForm.current = 1;
      this.getDataList();
    },
    handleSizeChange(val){
      this.searchForm.size = val;
      this.searchForm.current = 1;
      this.getDataList();
    },
    handleCurrentChange(val){
      this.searchForm.current = val;
      this.getDataList();
    },
    getShopByName () {
      this.$http({
        url: this.$http.adornUrl('/prod/category/getShopByName'),
        method: 'get',
        params: this.$http.adornParams({
        })
      }).then(({ data }) => {
       this.options = data.map(item=>{
        return {
          value:item.shopId,
          label:item.shopName
        }
       })
      })
    },
    // 获取数据列表
    getDataList () {
      this.dataListLoading = true
      this.searchForm.shopId = this.searchForm.shopId || undefined;
      this.$http({
        url: this.$http.adornUrl('/prod/category/listCategory'),
        method: 'get',
        params: this.$http.adornParams({
          maxGrade: 2,
          ...this.searchForm
        })
      }).then(({ data }) => {
        // this.dataList = treeDataTranslate(data, 'categoryId', 'parentId')
        this.dataList = data.records
        this.total = data.total;
        this.dataListLoading = false
      })
    },
    // 新增 / 修改
    addOrUpdateHandle (id) {
      this.addOrUpdateVisible = true
      this.$nextTick(() => {
        this.$refs.addOrUpdate.init(id)
      })
    },
    // 删除
    deleteHandle (id) {
      this.$confirm(`确定进行[删除]操作?`, '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        this.$http({
          url: this.$http.adornUrl(`/prod/category/${id}`),
          method: 'delete',
          data: this.$http.adornData()
        }).then(({ data }) => {
          this.$message({
            message: '操作成功',
            type: 'success',
            duration: 1500,
            onClose: () => {
              this.getDataList()
            }
          })
        })
      })
    }
  }
}
</script>
<style lang="scss">
.mod-category {
  img {
    height: 80px;
    width: 200px;
  }
}
</style>
